from typing import Callable, Sequence, Tuple

from _typeshed import Incomplete
from google.api_core import gapic_v1, retry_async as retries
from google.api_core.client_options import ClientOptions
from google.auth import credentials as ga_credentials

from google.ads.googleads.v20.enums.types import (
    data_link_status as gage_data_link_status,
)
from google.ads.googleads.v20.resources.types import data_link as gagr_data_link
from google.ads.googleads.v20.services.types import data_link_service

from .transports.base import DataLinkServiceTransport

__all__ = ["DataLinkServiceAsyncClient"]

class DataLinkServiceAsyncClient:
    DEFAULT_ENDPOINT: Incomplete
    DEFAULT_MTLS_ENDPOINT: Incomplete
    data_link_path: Incomplete
    parse_data_link_path: Incomplete
    common_billing_account_path: Incomplete
    parse_common_billing_account_path: Incomplete
    common_folder_path: Incomplete
    parse_common_folder_path: Incomplete
    common_organization_path: Incomplete
    parse_common_organization_path: Incomplete
    common_project_path: Incomplete
    parse_common_project_path: Incomplete
    common_location_path: Incomplete
    parse_common_location_path: Incomplete
    @classmethod
    def from_service_account_info(cls, info: dict, *args, **kwargs): ...
    @classmethod
    def from_service_account_file(cls, filename: str, *args, **kwargs): ...
    from_service_account_json = from_service_account_file
    @classmethod
    def get_mtls_endpoint_and_cert_source(
        cls, client_options: ClientOptions | None = None
    ): ...
    @property
    def transport(self) -> DataLinkServiceTransport: ...
    @property
    def api_endpoint(self): ...
    @property
    def universe_domain(self) -> str: ...
    get_transport_class: Incomplete
    def __init__(
        self,
        *,
        credentials: ga_credentials.Credentials | None = None,
        transport: str
        | DataLinkServiceTransport
        | Callable[..., DataLinkServiceTransport]
        | None = "grpc_asyncio",
        client_options: ClientOptions | None = None,
        client_info: gapic_v1.client_info.ClientInfo = ...,
    ) -> None: ...
    async def create_data_link(
        self,
        request: data_link_service.CreateDataLinkRequest | dict | None = None,
        *,
        customer_id: str | None = None,
        data_link: gagr_data_link.DataLink | None = None,
        retry: retries.AsyncRetry | gapic_v1.method._MethodDefault = ...,
        timeout: float | object = ...,
        metadata: Sequence[tuple[str, str | bytes]] = (),
    ) -> data_link_service.CreateDataLinkResponse: ...
    async def remove_data_link(
        self,
        request: data_link_service.RemoveDataLinkRequest | dict | None = None,
        *,
        customer_id: str | None = None,
        resource_name: str | None = None,
        retry: retries.AsyncRetry | gapic_v1.method._MethodDefault = ...,
        timeout: float | object = ...,
        metadata: Sequence[tuple[str, str | bytes]] = (),
    ) -> data_link_service.RemoveDataLinkResponse: ...
    async def update_data_link(
        self,
        request: data_link_service.UpdateDataLinkRequest | dict | None = None,
        *,
        customer_id: str | None = None,
        data_link_status: gage_data_link_status.DataLinkStatusEnum.DataLinkStatus
        | None = None,
        resource_name: str | None = None,
        retry: retries.AsyncRetry | gapic_v1.method._MethodDefault = ...,
        timeout: float | object = ...,
        metadata: Sequence[tuple[str, str | bytes]] = (),
    ) -> data_link_service.UpdateDataLinkResponse: ...
    async def __aenter__(self) -> DataLinkServiceAsyncClient: ...
    async def __aexit__(self, exc_type, exc, tb) -> None: ...
